
# Backend internal interview (rust) - improved  

## Verification

From [input.txt](input.txt) compare output with [output_expected.txt](output_expected.txt)

```bash
cargo run -q -- -i input.txt -q
```

From tests

```rust
cargo test test_expected_metrics
```

**test_expectd_metrics** can be found at the end of [tests.rs](src/tests.rs)

> DEFAULT_INPUT_PATH and DEFAULT_REG_EXP values can be found in [defs.rs](src/defs.rs)

### For parallel processing

A second file [input_2.txt](input_2.txt) has been created and included in [config.toml](config.toml)

```rust
cargo run -q
```

It the same as:

```rust
cargo run -q -- -c config.toml
```

> [!NOTE]
> [config.toml](config.toml) is DEFAULT_CONFIG_PATH if does not exists it will only use DEFAULT_INPUT_PATH [input.txt](input.txt)

## Read Documentation

Build documentation and browse to **main** page

```rust
cargo doc --no-deps --open
```

Source code contains doc text.  

## How to use

For more explanations use [how to use](howto.md)