# Backend internal interview (rust) - improved  

This **Improved** branch is a rather disruptive approach to the [initial proposal](https://repo.jesusperez.pro/jesus/be-technical-interview-rust)<br>
[Branch basic-fixed](https://repo.jesusperez.pro/jesus/be-technical-interview-rust/src/branch/basic-fixed) tried to solve proposal from initial code 
as a **continuity effort** with the necessary changes and some improvement adjustments such as the **parallel input processing**

> [!NOTE]
> A full refactoring done for <u>better quality, maintenance and readability</u>. (Structs, implementaitions, settings for multiple inputs, etc). <br>
> It is able to **process multiple metrics in parallel**. <br>

## In summary

- [x]  Define a basic model, easily to extend and modify. **Abstraction / Generic**.
- [x]  Structs and implementations to specific metricis traitments. **Modular appoach**.
- [x]  Settings and configuration for interactive and non interactive processing (batch mode) **Customize on context**.

See [main changes](/jesus/be-technical-interview-rust/src/branch/improved/CHANGES.md)

> [!IMPORTANT]  
> Use [ABOUT](ABOUT.md) content for quick [Verification](ABOUT.md) (it requires download and build)

## Benefits

Elements items come from  [main changes](/jesus/be-technical-interview-rust/src/branch/improved/CHANGES.md)

| Element          | Benefit |
|----------------- |---------|
| Generic traits   | Group generic task for metric processing, steps / tasks separation |
| Structs          | Customize atributes and implementation for specific target or patterns  |
| Enums with values| Associate attributes metrics and values, easy to add new attributes or combine with different values at once |
| Vectors          | Simplify types / grouped in structs, priorize vectors type, easy to iterate, filter, sort, etc |
| Const and Config | Group main const, define metric targes and operations in declarative mode for non intective traitment |
| Command line args| Help to run in terminal as a cli |
| Unit Tests       | Verify some operations results |

> [!TIP]  
> After download repository and build:

> - Use [howto](howto.md) for command, options, etc.
> - Build documentation and browse content whit source code (instruction in [about](ABOUT.md))
> - Files layout notes in [layout.md](layout.md)


## Ideas not included

- **Async I/O** to scale and performance ?
- Other Thread alternatives like [Tokio](https://tokio.rs/) or/and [Coroutines](https://doc.rust-lang.org/std/ops/trait.Coroutine.html)
- Benchmarking for optimization
- More **tests**
- Run as **API mode** not only as batch processing

> [!NOTE]
> Code is in a private repository with several other branches.<br>
> Link to [branch repository improved](https://repo.jesusperez.pro/jesus/be-technical-interview-rust/src/branch/improved)

---

[Home Task exercise description](Home-Task_exercise_interview_Rust.pdf)

There are several branches developed as proposal:

- [Basic fixed one](/jesus/be-technical-interview-rust/src/branch/basic-fixed)
  > A basic code review, fixed with minor and essential changes to work as expected. <br>
  > Tests are included for verification. <br>

- [Improve one](/jesus/be-technical-interview-rust/src/branch/improved)
