
# Backend internal interview (rust) - improved

## How to used

**cargo run --** can be replaced for generated binaries with
 
- target/debug/be-technical-interview-rust (for debug build)
- target/release/be-technical-interview-rust (for release build)

### For help

```bash
cargo run -- -h
```

### For input file **input.txt**

```bash
cargo run -- -i input.txt
```

### In quiet mode

```bash
cargo run -- -i input.txt -q
```

if **output path** is provided, results will be saved in provided path,<br>
without **quiet mode** info is printed to terminal

```bash
cargo run -- -i input.txt -o /tmp/output.txt
```

### Use config path. **Batch processing in parallel** (one thread for each target) 

```bash
cargo run -- -c config.toml
```

### Config file content

```toml
be_quiet = false
[[targets]]
input = "input.txt"

[[targets]]
input = "input_2.txt"
```

If **output** path is provided, **out_overwrite** can be used (true or false) to append conten or rewrite.

By default:

- **out_overwrite** is **true**
- *reg_exp** is set as

```rust
pub const DEFAULT_REG_EXP: &str = r"(\d+) (\w+) (\d+)";
```

**reg_exp** can be provided but as a **regex** expresion from **string**, if it can not be converted parser exit.

To solve this 

```toml
be_quiet = false 
[[targets]]
input = "input.txt"
# \ has to be escaped 
reg_exp = "(\\d+) (\\w+) (\\d+)"

[[targets]]
input = "input_2.txt"
```

> [!CAUTION]
> Command line options have precedence over **config path** settings. <br>
> Be careful with the combinations
