//! ## Definitions (settings and in common types)
//! - Group some types definitions in a directory
//! - Includes global **const** as **&str**
//! - Export / shared to other code files in crate or public
mod cli;
mod config;
pub mod metric_data;
pub mod metrics;

pub(crate) use cli::{parse_args, CliSettings};
pub(crate) use config::{load_from_file, Config};
pub(crate) use metric_data::MetricsConsumerData;
pub(crate) use metrics::MetricParser;

pub const PKG_NAME: &str = env!("CARGO_PKG_NAME");
pub const PKG_VERSION: &str = env!("CARGO_PKG_VERSION");
pub const CFG_FILE_EXTENSION: &str = ".toml";
pub const DEFAULT_CONFIG_PATH: &str = "config.toml";
pub const DEFAULT_INPUT_PATH: &str = "input.txt";
pub const DEFAULT_REG_EXP: &str = r"(\d+) (\w+) (\d+)";
