//! ## metrics definitions generic models.
//! - Abstraction via **traits**
//! - Generic process / tasks / steps required for metrics traitment.

use regex::Regex;
use std::{error::Error, fs::File};

pub trait MetricParser
where
    Self: Sized,
{
    fn input(&self) -> String;
    fn load_input(&self) -> Result<Self, Box<dyn Error>>;
    fn parse(&self, file: File, reg_exp: Regex) -> Self;
    fn collect_aggregates(&mut self);
    fn show_metrics(&self) -> Result<Vec<String>, std::io::Error>;
}
